
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Shiro学习（19）动态URL权限限制 / 憋错料</title>

    <meta name="description" content="Shiro学习（19）动态URL权限限制 用过Spring Security的朋友应该比较熟悉对URL进行全局的权限控制,即访问URL时进行权限匹配:如果没有权限直接跳到相应的错误页面.Shiro也支持类似的机制,不过需要稍微改造下来满足实际需求.不过在Shiro中,更多的是通过AOP进行分散的权限控制,即方法级别的:而通过URL进行权限控制是一种集中的权限控制.本章将介绍如何在Shiro中完成动态URL权限控制. 本章代码基于&lt;第十六章 综合实例&gt;,请先了解相关数据模型及基本流程后再学习本章. 表及数据SQL 请运行shi ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Shiro学习（19）动态URL权限限制</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>用过Spring Security的朋友应该比较熟悉对URL进行全局的权限控制，即访问URL时进行权限匹配；如果没有权限直接跳到相应的错误页面。Shiro也支持类&#20284;的机制，不过需要稍微改造下来满足实际需求。不过在Shiro中，更多的是通过AOP进行分散的权限控制，即方法级别的；而通过URL进行权限控制是一种集中的权限控制。本章将介绍如何在Shiro中完成动态URL权限控制。</p>
<p>本章代码基于《第十六章&nbsp;综合实例》，请先了解相关数据模型及基本流程后再学习本章。</p>
<p><strong>表及数据SQL</strong></p>
<p>请运行shiro-example-chapter19/sql/ shiro-schema.sql&nbsp;表结构</p>
<p>请运行shiro-example-chapter19/sql/ shiro-schema.sql&nbsp;数据</p>
<p><strong>实体</strong></p>
<p>具体请参考com.github.zhangkaitao.shiro.chapter19包下的实体。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>public&nbsp;class&nbsp;UrlFilter&nbsp;implements&nbsp;Serializable&nbsp;{</li>
<li>private&nbsp;Long&nbsp;id;</li>
<li>private&nbsp;String&nbsp;name;&nbsp;//url名称/描述</li>
<li>private&nbsp;String&nbsp;url;&nbsp;//地址</li>
<li>private&nbsp;String&nbsp;roles;&nbsp;//所需要的角色，可省略</li>
<li>private&nbsp;String&nbsp;permissions;&nbsp;//所需要的权限，可省略</li>
<li>}</li>
</ol>
<p>表示拦截的URL和角色/权限之间的关系，多个角色/权限之间通过逗号分隔，此处还可以扩展其他的关系，另外可以加如available属性表示是否开启该拦截。</p>
<p><strong>DAO</strong></p>
<p>具体请参考com.github.zhangkaitao.shiro.chapter19.dao包下的DAO接口及实现。</p>
<p><strong>Service</strong></p>
<p>具体请参考com.github.zhangkaitao.shiro.chapter19.service包下的Service接口及实现。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>public&nbsp;interface&nbsp;UrlFilterService&nbsp;{</li>
<li>public&nbsp;UrlFilter&nbsp;createUrlFilter(UrlFilter&nbsp;urlFilter);</li>
<li>public&nbsp;UrlFilter&nbsp;updateUrlFilter(UrlFilter&nbsp;urlFilter);</li>
<li>public&nbsp;void&nbsp;deleteUrlFilter(Long&nbsp;urlFilterId);</li>
<li>public&nbsp;UrlFilter&nbsp;findOne(Long&nbsp;urlFilterId);</li>
<li>public&nbsp;List&lt;UrlFilter&gt;&nbsp;findAll();</li>
<li>}</li>
</ol>
<p>基本的URL拦截的增删改查实现。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>@Service</li>
<li>public&nbsp;class&nbsp;UrlFilterServiceImpl&nbsp;implements&nbsp;UrlFilterService&nbsp;{</li>
<li>@Autowired</li>
<li>private&nbsp;ShiroFilerChainManager&nbsp;shiroFilerChainManager;</li>
<li>@Override</li>
<li>public&nbsp;UrlFilter&nbsp;createUrlFilter(UrlFilter&nbsp;urlFilter)&nbsp;{</li>
<li>urlFilterDao.createUrlFilter(urlFilter);</li>
<li>initFilterChain();</li>
<li>return&nbsp;urlFilter;</li>
<li>}</li>
<li>//其他方法请参考源码</li>
<li>@PostConstruct</li>
<li>public&nbsp;void&nbsp;initFilterChain()&nbsp;{</li>
<li>shiroFilerChainManager.initFilterChains(findAll());</li>
<li>}</li>
<li>}</li>
</ol>
<p>UrlFilterServiceImpl在进行新增、修改、删除时会调用initFilterChain来重新初始化Shiro的URL拦截器链，即同步数据库中的URL拦截器定义到Shiro中。此处也要注意如果直接修改数据库是不会起作用的，因为只要调用这几个Service方法时才同步。另外当容器启动时会自动回调initFilterChain来完成容器启动后的URL拦截器的注册。</p>
<p><strong>ShiroFilerChainManager</strong></p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>@Service</li>
<li>public&nbsp;class&nbsp;ShiroFilerChainManager&nbsp;{</li>
<li>@Autowired&nbsp;private&nbsp;DefaultFilterChainManager&nbsp;filterChainManager;</li>
<li>private&nbsp;Map&lt;String,&nbsp;NamedFilterList&gt;&nbsp;defaultFilterChains;</li>
<li>@PostConstruct</li>
<li>public&nbsp;void&nbsp;init()&nbsp;{</li>
<li>defaultFilterChains&nbsp;=</li>
<li>new&nbsp;HashMap&lt;String,&nbsp;NamedFilterList&gt;(filterChainManager.getFilterChains());</li>
<li>}</li>
<li>public&nbsp;void&nbsp;initFilterChains(List&lt;UrlFilter&gt;&nbsp;urlFilters)&nbsp;{</li>
<li>//1、首先删除以前老的filter&nbsp;chain并注册默认的</li>
<li>filterChainManager.getFilterChains().clear();</li>
<li>if(defaultFilterChains&nbsp;!=&nbsp;null)&nbsp;{</li>
<li>filterChainManager.getFilterChains().putAll(defaultFilterChains);</li>
<li>}</li>
<li>//2、循环URL&nbsp;Filter&nbsp;注册filter&nbsp;chain</li>
<li>for&nbsp;(UrlFilter&nbsp;urlFilter&nbsp;:&nbsp;urlFilters)&nbsp;{</li>
<li>String&nbsp;url&nbsp;=&nbsp;urlFilter.getUrl();</li>
<li>//注册roles&nbsp;filter</li>
<li>if&nbsp;(!StringUtils.isEmpty(urlFilter.getRoles()))&nbsp;{</li>
<li>filterChainManager.addToChain(url,&nbsp;&quot;roles&quot;,&nbsp;urlFilter.getRoles());</li>
<li>}</li>
<li>//注册perms&nbsp;filter</li>
<li>if&nbsp;(!StringUtils.isEmpty(urlFilter.getPermissions()))&nbsp;{</li>
<li>filterChainManager.addToChain(url,&nbsp;&quot;perms&quot;,&nbsp;urlFilter.getPermissions());</li>
<li>}</li>
<li>}</li>
<li>}</li>
<li>}</li>
</ol>
<p>1、init：Spring容器启动时会调用init方法把在spring配置文件中配置的默认拦截器保存下来，之后会自动与数据库中的配置进行合并。</p>
<p>2、initFilterChains：UrlFilterServiceImpl会在Spring容器启动或进行增删改UrlFilter时进行注册URL拦截器到Shiro。</p>
<p>拦截器及拦截器链知识请参考《第八章&nbsp;拦截器机制》，此处再介绍下Shiro拦截器的流程：</p>
<p>AbstractShiroFilter //如ShiroFilter/ SpringShiroFilter都继承该Filter</p>
<p>doFilter //Filter的doFilter</p>
<p>doFilterInternal //转调doFilterInternal</p>
<p>executeChain(request, response, chain) //执行拦截器链</p>
<p>FilterChain chain = getExecutionChain(request, response, origChain) //使用原始拦截器链获取新的拦截器链</p>
<p>chain.doFilter(request, response) //执行新组装的拦截器链</p>
<p>getExecutionChain(request, response, origChain) //获取拦截器链流程</p>
<p>FilterChainResolver resolver = getFilterChainResolver(); //获取相应的FilterChainResolver</p>
<p>FilterChain resolved = resolver.getChain(request, response, origChain); //通过FilterChainResolver根据当前请求解析到新的FilterChain拦截器链</p>
<p>默认情况下如使用ShiroFilterFactoryBean创建shiroFilter时，默认使用PathMatchingFilterChainResolver进行解析，而它默认是根据当前请求的URL获取相应的拦截器链，使用Ant模式进行URL匹配；默认使用DefaultFilterChainManager进行拦截器链的管理。</p>
<p>PathMatchingFilterChainResolver默认流程：</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>public&nbsp;FilterChain&nbsp;getChain(ServletRequest&nbsp;request,&nbsp;ServletResponse&nbsp;response,&nbsp;FilterChain&nbsp;originalChain)&nbsp;{</li>
<li>//1、首先获取拦截器链管理器</li>
<li>FilterChainManager&nbsp;filterChainManager&nbsp;=&nbsp;getFilterChainManager();</li>
<li>if&nbsp;(!filterChainManager.hasChains())&nbsp;{</li>
<li>return&nbsp;null;</li>
<li>}</li>
<li>//2、接着获取当前请求的URL（不带上下文）</li>
<li>String&nbsp;requestURI&nbsp;=&nbsp;getPathWithinApplication(request);</li>
<li>//3、循环拦截器管理器中的拦截器定义（拦截器链的名字就是URL模式）</li>
<li>for&nbsp;(String&nbsp;pathPattern&nbsp;:&nbsp;filterChainManager.getChainNames())&nbsp;{</li>
<li>//4、如当前URL匹配拦截器名字（URL模式）</li>
<li>if&nbsp;(pathMatches(pathPattern,&nbsp;requestURI))&nbsp;{</li>
<li>//5、返回该URL模式定义的拦截器链</li>
<li>return&nbsp;filterChainManager.proxy(originalChain,&nbsp;pathPattern);</li>
<li>}</li>
<li>}</li>
<li>return&nbsp;null;</li>
<li>}</li>
</ol>
<p>默认实现有点小问题：</p>
<p>如果多个拦截器链都匹配了当前请求URL，那么只返回第一个找到的拦截器链；后续我们可以修改此处的代码，将多个匹配的拦截器链合并返回。</p>
<p>DefaultFilterChainManager内部使用Map来管理URL模式-拦截器链的关系；也就是说相同的URL模式只能定义一个拦截器链，不能重复定义；而且如果多个拦截器链都匹配时是无序的（因为使用map.keySet()获取拦截器链的名字，即URL模式）。</p>
<p>FilterChainManager接口：</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>public&nbsp;interface&nbsp;FilterChainManager&nbsp;{</li>
<li>Map&lt;String,&nbsp;Filter&gt;&nbsp;getFilters();&nbsp;//得到注册的拦截器</li>
<li>void&nbsp;addFilter(String&nbsp;name,&nbsp;Filter&nbsp;filter);&nbsp;//注册拦截器</li>
<li>void&nbsp;addFilter(String&nbsp;name,&nbsp;Filter&nbsp;filter,&nbsp;boolean&nbsp;init);&nbsp;//注册拦截器</li>
<li>void&nbsp;createChain(String&nbsp;chainName,&nbsp;String&nbsp;chainDefinition);&nbsp;//根据拦截器链定义创建拦截器链</li>
<li>void&nbsp;addToChain(String&nbsp;chainName,&nbsp;String&nbsp;filterName);&nbsp;//添加拦截器到指定的拦截器链</li>
<li>void&nbsp;addToChain(String&nbsp;chainName,&nbsp;String&nbsp;filterName,&nbsp;String&nbsp;chainSpecificFilterConfig)&nbsp;throws&nbsp;ConfigurationException;&nbsp;//添加拦截器（带有配置的）到指定的拦截器链</li>
<li>NamedFilterList&nbsp;getChain(String&nbsp;chainName);&nbsp;//获取拦截器链</li>
<li>boolean&nbsp;hasChains();&nbsp;//是否有拦截器链</li>
<li>Set&lt;String&gt;&nbsp;getChainNames();&nbsp;//得到所有拦截器链的名字</li>
<li>FilterChain&nbsp;proxy(FilterChain&nbsp;original,&nbsp;String&nbsp;chainName);&nbsp;//使用指定的拦截器链代理原始拦截器链</li>
<li>}</li>
</ol>
<p>此接口主要三个功能：注册拦截器，注册拦截器链，对原始拦截器链生成代理之后的拦截器链，比如</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>&lt;bean&nbsp;id=&quot;shiroFilter&quot;&nbsp;class=&quot;org.apache.shiro.spring.web.ShiroFilterFactoryBean&quot;&gt;</li>
<li>……</li>
<li>&lt;property&nbsp;name=&quot;filters&quot;&gt;</li>
<li>&lt;util:map&gt;</li>
<li>&lt;entry&nbsp;key=&quot;authc&quot;&nbsp;value-ref=&quot;formAuthenticationFilter&quot;/&gt;</li>
<li>&lt;entry&nbsp;key=&quot;sysUser&quot;&nbsp;value-ref=&quot;sysUserFilter&quot;/&gt;</li>
<li>&lt;/util:map&gt;</li>
<li>&lt;/property&gt;</li>
<li>&lt;property&nbsp;name=&quot;filterChainDefinitions&quot;&gt;</li>
<li>&lt;value&gt;</li>
<li>/login&nbsp;=&nbsp;authc</li>
<li>/logout&nbsp;=&nbsp;logout</li>
<li>/authenticated&nbsp;=&nbsp;authc</li>
<li>/**&nbsp;=&nbsp;user,sysUser</li>
<li>&lt;/value&gt;</li>
<li>&lt;/property&gt;</li>
<li>&lt;/bean&gt;</li>
</ol>
<p>filters属性定义了拦截器；filterChainDefinitions定义了拦截器链；如/**就是拦截器链的名字；而user,sysUser就是拦截器名字列表。</p>
<p>之前说过默认的PathMatchingFilterChainResolver和DefaultFilterChainManager不能满足我们的需求，我们稍微扩展了一下：</p>
<p><strong>CustomPathMatchingFilterChainResolver</strong></p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>public&nbsp;class&nbsp;CustomPathMatchingFilterChainResolver</li>
<li>extends&nbsp;PathMatchingFilterChainResolver&nbsp;{</li>
<li>private&nbsp;CustomDefaultFilterChainManager&nbsp;customDefaultFilterChainManager;</li>
<li>public&nbsp;void&nbsp;setCustomDefaultFilterChainManager(</li>
<li>CustomDefaultFilterChainManager&nbsp;customDefaultFilterChainManager)&nbsp;{</li>
<li>this.customDefaultFilterChainManager&nbsp;=&nbsp;customDefaultFilterChainManager;</li>
<li>setFilterChainManager(customDefaultFilterChainManager);</li>
<li>}</li>
<li>public&nbsp;FilterChain&nbsp;getChain(ServletRequest&nbsp;request,&nbsp;ServletResponse&nbsp;response,&nbsp;FilterChain&nbsp;originalChain)&nbsp;{</li>
<li>FilterChainManager&nbsp;filterChainManager&nbsp;=&nbsp;getFilterChainManager();</li>
<li>if&nbsp;(!filterChainManager.hasChains())&nbsp;{</li>
<li>return&nbsp;null;</li>
<li>}</li>
<li>String&nbsp;requestURI&nbsp;=&nbsp;getPathWithinApplication(request);</li>
<li>List&lt;String&gt;&nbsp;chainNames&nbsp;=&nbsp;new&nbsp;ArrayList&lt;String&gt;();</li>
<li>for&nbsp;(String&nbsp;pathPattern&nbsp;:&nbsp;filterChainManager.getChainNames())&nbsp;{</li>
<li>if&nbsp;(pathMatches(pathPattern,&nbsp;requestURI))&nbsp;{</li>
<li>chainNames.add(pathPattern);</li>
<li>}</li>
<li>}</li>
<li>if(chainNames.size()&nbsp;==&nbsp;0)&nbsp;{</li>
<li>return&nbsp;null;</li>
<li>}</li>
<li>return&nbsp;customDefaultFilterChainManager.proxy(originalChain,&nbsp;chainNames);</li>
<li>}</li>
<li>}</li>
</ol>
<p>和默认的PathMatchingFilterChainResolver区别是，此处得到所有匹配的拦截器链，然后通过调用CustomDefaultFilterChainManager.proxy(originalChain, chainNames)进行合并后代理。</p>
<p><strong>CustomDefaultFilterChainManager</strong></p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>public&nbsp;class&nbsp;CustomDefaultFilterChainManager&nbsp;extends&nbsp;DefaultFilterChainManager&nbsp;{</li>
<li>private&nbsp;Map&lt;String,&nbsp;String&gt;&nbsp;filterChainDefinitionMap&nbsp;=&nbsp;null;</li>
<li>private&nbsp;String&nbsp;loginUrl;</li>
<li>private&nbsp;String&nbsp;successUrl;</li>
<li>private&nbsp;String&nbsp;unauthorizedUrl;</li>
<li>public&nbsp;CustomDefaultFilterChainManager()&nbsp;{</li>
<li>setFilters(new&nbsp;LinkedHashMap&lt;String,&nbsp;Filter&gt;());</li>
<li>setFilterChains(new&nbsp;LinkedHashMap&lt;String,&nbsp;NamedFilterList&gt;());</li>
<li>addDefaultFilters(true);</li>
<li>}</li>
<li>public&nbsp;Map&lt;String,&nbsp;String&gt;&nbsp;getFilterChainDefinitionMap()&nbsp;{</li>
<li>return&nbsp;filterChainDefinitionMap;</li>
<li>}</li>
<li>public&nbsp;void&nbsp;setFilterChainDefinitionMap(Map&lt;String,&nbsp;String&gt;&nbsp;filterChainDefinitionMap)&nbsp;{</li>
<li>this.filterChainDefinitionMap&nbsp;=&nbsp;filterChainDefinitionMap;</li>
<li>}</li>
<li>public&nbsp;void&nbsp;setCustomFilters(Map&lt;String,&nbsp;Filter&gt;&nbsp;customFilters)&nbsp;{</li>
<li>for(Map.Entry&lt;String,&nbsp;Filter&gt;&nbsp;entry&nbsp;:&nbsp;customFilters.entrySet())&nbsp;{</li>
<li>addFilter(entry.getKey(),&nbsp;entry.getValue(),&nbsp;false);</li>
<li>}</li>
<li>}</li>
<li>public&nbsp;void&nbsp;setDefaultFilterChainDefinitions(String&nbsp;definitions)&nbsp;{</li>
<li>Ini&nbsp;ini&nbsp;=&nbsp;new&nbsp;Ini();</li>
<li>ini.load(definitions);</li>
<li>Ini.Section&nbsp;section&nbsp;=&nbsp;ini.getSection(IniFilterChainResolverFactory.URLS);</li>
<li>if&nbsp;(CollectionUtils.isEmpty(section))&nbsp;{</li>
<li>section&nbsp;=&nbsp;ini.getSection(Ini.DEFAULT_SECTION_NAME);</li>
<li>}</li>
<li>setFilterChainDefinitionMap(section);</li>
<li>}</li>
<li>public&nbsp;String&nbsp;getLoginUrl()&nbsp;{</li>
<li>return&nbsp;loginUrl;</li>
<li>}</li>
<li>public&nbsp;void&nbsp;setLoginUrl(String&nbsp;loginUrl)&nbsp;{</li>
<li>this.loginUrl&nbsp;=&nbsp;loginUrl;</li>
<li>}</li>
<li>public&nbsp;String&nbsp;getSuccessUrl()&nbsp;{</li>
<li>return&nbsp;successUrl;</li>
<li>}</li>
<li>public&nbsp;void&nbsp;setSuccessUrl(String&nbsp;successUrl)&nbsp;{</li>
<li>this.successUrl&nbsp;=&nbsp;successUrl;</li>
<li>}</li>
<li>public&nbsp;String&nbsp;getUnauthorizedUrl()&nbsp;{</li>
<li>return&nbsp;unauthorizedUrl;</li>
<li>}</li>
<li>public&nbsp;void&nbsp;setUnauthorizedUrl(String&nbsp;unauthorizedUrl)&nbsp;{</li>
<li>this.unauthorizedUrl&nbsp;=&nbsp;unauthorizedUrl;</li>
<li>}</li>
<li>@PostConstruct</li>
<li>public&nbsp;void&nbsp;init()&nbsp;{</li>
<li>Map&lt;String,&nbsp;Filter&gt;&nbsp;filters&nbsp;=&nbsp;getFilters();</li>
<li>if&nbsp;(!CollectionUtils.isEmpty(filters))&nbsp;{</li>
<li>for&nbsp;(Map.Entry&lt;String,&nbsp;Filter&gt;&nbsp;entry&nbsp;:&nbsp;filters.entrySet())&nbsp;{</li>
<li>String&nbsp;name&nbsp;=&nbsp;entry.getKey();</li>
<li>Filter&nbsp;filter&nbsp;=&nbsp;entry.getValue();</li>
<li>applyGlobalPropertiesIfNecessary(filter);</li>
<li>if&nbsp;(filter&nbsp;instanceof&nbsp;Nameable)&nbsp;{</li>
<li>((Nameable)&nbsp;filter).setName(name);</li>
<li>}</li>
<li>addFilter(name,&nbsp;filter,&nbsp;false);</li>
<li>}</li>
<li>}</li>
<li>Map&lt;String,&nbsp;String&gt;&nbsp;chains&nbsp;=&nbsp;getFilterChainDefinitionMap();</li>
<li>if&nbsp;(!CollectionUtils.isEmpty(chains))&nbsp;{</li>
<li>for&nbsp;(Map.Entry&lt;String,&nbsp;String&gt;&nbsp;entry&nbsp;:&nbsp;chains.entrySet())&nbsp;{</li>
<li>String&nbsp;url&nbsp;=&nbsp;entry.getKey();</li>
<li>String&nbsp;chainDefinition&nbsp;=&nbsp;entry.getValue();</li>
<li>createChain(url,&nbsp;chainDefinition);</li>
<li>}</li>
<li>}</li>
<li>}</li>
<li>protected&nbsp;void&nbsp;initFilter(Filter&nbsp;filter)&nbsp;{</li>
<li>//ignore</li>
<li>}</li>
<li>public&nbsp;FilterChain&nbsp;proxy(FilterChain&nbsp;original,&nbsp;List&lt;String&gt;&nbsp;chainNames)&nbsp;{</li>
<li>NamedFilterList&nbsp;configured&nbsp;=&nbsp;new&nbsp;SimpleNamedFilterList(chainNames.toString());</li>
<li>for(String&nbsp;chainName&nbsp;:&nbsp;chainNames)&nbsp;{</li>
<li>configured.addAll(getChain(chainName));</li>
<li>}</li>
<li>return&nbsp;configured.proxy(original);</li>
<li>}</li>
<li>private&nbsp;void&nbsp;applyGlobalPropertiesIfNecessary(Filter&nbsp;filter)&nbsp;{</li>
<li>applyLoginUrlIfNecessary(filter);</li>
<li>applySuccessUrlIfNecessary(filter);</li>
<li>applyUnauthorizedUrlIfNecessary(filter);</li>
<li>}</li>
<li>private&nbsp;void&nbsp;applyLoginUrlIfNecessary(Filter&nbsp;filter)&nbsp;{</li>
<li>//请参考源码</li>
<li>}</li>
<li>private&nbsp;void&nbsp;applySuccessUrlIfNecessary(Filter&nbsp;filter)&nbsp;{</li>
<li>//请参考源码</li>
<li>}</li>
<li>private&nbsp;void&nbsp;applyUnauthorizedUrlIfNecessary(Filter&nbsp;filter)&nbsp;{</li>
<li>//请参考源码</li>
<li>}</li>
<li>}</li>
</ol>
<p>1、CustomDefaultFilterChainManager：调用其构造器时，会自动注册默认的拦截器；</p>
<p>2、loginUrl、successUrl、unauthorizedUrl：分别对应登录地址、登录成功后默认跳转地址、未授权跳转地址，用于给相应拦截器的；</p>
<p>3、filterChainDefinitionMap：用于存储如ShiroFilterFactoryBean在配置文件中配置的拦截器链定义，即可以认为是默认的静态拦截器链；会自动与数据库中加载的合并；</p>
<p>4、setDefaultFilterChainDefinitions：解析配置文件中传入的字符串拦截器链配置，解析为相应的拦截器链；</p>
<p>5、setCustomFilters：注册我们自定义的拦截器；如ShiroFilterFactoryBean的filters属性；</p>
<p>6、init：初始化方法，Spring容器启动时会调用，首先其会自动给相应的拦截器设置如loginUrl、successUrl、unauthorizedUrl；其次根据filterChainDefinitionMap构建默认的拦截器链；</p>
<p>7、initFilter：此处我们忽略实现initFilter，因为交给spring管理了，所以Filter的相关配置会在Spring配置中完成；</p>
<p>8、proxy：组合多个拦截器链为一个生成一个新的FilterChain代理。</p>
<p><strong>Web层控制器&nbsp;</strong></p>
<p>请参考com.github.zhangkaitao.shiro.chapter19.web.controller包，相对于第十六章添加了UrlFilterController用于UrlFilter的维护。另外，移除了控制器方法上的权限注解，而是使用动态URL拦截进行控制。</p>
<p><strong>Spring配置——spring-config-shiro.xml</strong></p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>&lt;bean&nbsp;id=&quot;filterChainManager&quot;</li>
<li>class=&quot;com.github.zhangkaitao.shiro.spring.CustomDefaultFilterChainManager&quot;&gt;</li>
<li>&lt;property&nbsp;name=&quot;loginUrl&quot;&nbsp;value=&quot;/login&quot;/&gt;</li>
<li>&lt;property&nbsp;name=&quot;successUrl&quot;&nbsp;value=&quot;/&quot;/&gt;</li>
<li>&lt;property&nbsp;name=&quot;unauthorizedUrl&quot;&nbsp;value=&quot;/unauthorized.jsp&quot;/&gt;</li>
<li>&lt;property&nbsp;name=&quot;customFilters&quot;&gt;</li>
<li>&lt;util:map&gt;</li>
<li>&lt;entry&nbsp;key=&quot;authc&quot;&nbsp;value-ref=&quot;formAuthenticationFilter&quot;/&gt;</li>
<li>&lt;entry&nbsp;key=&quot;sysUser&quot;&nbsp;value-ref=&quot;sysUserFilter&quot;/&gt;</li>
<li>&lt;/util:map&gt;</li>
<li>&lt;/property&gt;</li>
<li>&lt;property&nbsp;name=&quot;defaultFilterChainDefinitions&quot;&gt;</li>
<li>&lt;value&gt;</li>
<li>/login&nbsp;=&nbsp;authc</li>
<li>/logout&nbsp;=&nbsp;logout</li>
<li>/unauthorized.jsp&nbsp;=&nbsp;authc</li>
<li>/**&nbsp;=&nbsp;user,sysUser</li>
<li>&lt;/value&gt;</li>
<li>&lt;/property&gt;</li>
<li>&lt;/bean&gt;</li>
</ol>
<p>filterChainManager是我们自定义的CustomDefaultFilterChainManager，注册相应的拦截器及默认的拦截器链。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>&lt;bean&nbsp;id=&quot;filterChainResolver&quot;</li>
<li>class=&quot;com.github.zhangkaitao.shiro.spring.CustomPathMatchingFilterChainResolver&quot;&gt;</li>
<li>&lt;property&nbsp;name=&quot;customDefaultFilterChainManager&quot;&nbsp;ref=&quot;filterChainManager&quot;/&gt;</li>
<li>&lt;/bean&gt;</li>
</ol>
<p>filterChainResolver是自定义的CustomPathMatchingFilterChainResolver，使用上边的filterChainManager进行拦截器链的管理。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>&lt;bean&nbsp;id=&quot;shiroFilter&quot;&nbsp;class=&quot;org.apache.shiro.spring.web.ShiroFilterFactoryBean&quot;&gt;</li>
<li>&lt;property&nbsp;name=&quot;securityManager&quot;&nbsp;ref=&quot;securityManager&quot;/&gt;</li>
<li>&lt;/bean&gt;</li>
</ol>
<p>shiroFilter不再定义filters及filterChainDefinitions，而是交给了filterChainManager进行完成。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvamlubmlhbnNoaWxvbmduaWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></p>
<ol>
<li>&lt;bean&nbsp;class=&quot;org.springframework.beans.factory.config.MethodInvokingFactoryBean&quot;&gt;</li>
<li>&lt;property&nbsp;name=&quot;targetObject&quot;&nbsp;ref=&quot;shiroFilter&quot;/&gt;</li>
<li>&lt;property&nbsp;name=&quot;targetMethod&quot;&nbsp;value=&quot;setFilterChainResolver&quot;/&gt;</li>
<li>&lt;property&nbsp;name=&quot;arguments&quot;&nbsp;ref=&quot;filterChainResolver&quot;/&gt;</li>
<li>&lt;/bean&gt;</li>
</ol>
<p>最后把filterChainResolver注册给shiroFilter，其使用它进行动态URL权限控制。</p>
<p>其他配置和第十六章一样，请参考第十六章。</p>
<p><strong>测试</strong></p>
<p>1、首先执行shiro-data.sql初始化数据。</p>
<p>2、然后再URL管理中新增如下数据：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGwyLml0ZXllLmNvbS91cGxvYWQvYXR0YWNobWVudC8wMDk1LzQ4NzAvZTUyOWZmYTItYzZkYS0zOTJkLWFmMGEtNzgxNzcxNmQyODcwLnBuZw==.jpg"></p>
<p>3、访问http://localhost:8080/chapter19/user时要求用户拥有aa角色，此时是没有的所以会跳转到未授权页面；</p>
<p>4、添加aa角色然后授权给用户，此时就有权限访问http://localhost:8080/chapter19/user。</p>
<p>实际项目可以在此基础上进行扩展。</p>
<p>版权声明：欢迎转载，希望在你转载的同时，添加原文地址，谢谢配合</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 07:51:47 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Shiro学习（19）动态URL权限限制的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoK5QPM.html" rel="bookmark">Spring Security 动态url权限控制（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.前言 本篇文章将讲述Spring Security 动态分配url权限,未登录权限控制,登录过后根据登录用户角色授予访问url权限 基本环境 spring-boot 2.1.8 mybatis-plus 2.2.0 mysql 数据库 maven项目 Spring Security入门学习可参考之前文章: SpringBoot集成Spring Security入门体验(一)https://blog.csdn.net/qq_38225558/article/details/101754743			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPXoz1M.html" rel="bookmark">Shiro学习（总结）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				声明:本文原文地址:http://www.iteye.com/blogs/subjects/shiro 感谢开涛提供的博文,让我学到了很多,在这里由衷的感谢你,同时我强烈的推荐开涛的博文,他的博文力争完美,讲解细致,是基于实际的项目进行讲解,有理有据值得学习和借鉴.同时,在这里自荐一下,也希望大家也能够多多的关注我的博文,希望你的技术有所提高,大家共同学习共同进步. 下面是开涛整理的Shiro的目录,供大家学习. Shiro目录 第一章  Shiro简介 第二章  身份验证 第三章  授权 第四			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Q6W9kM.html" rel="bookmark">springboot&plus;shiro&plus;redis&lpar;单机redis版&rpar;整合教程-续&lpar;添加动态角色权限控制&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				相关教程: 1. springboot+shiro整合教程 2. springboot+shiro+redis(单机redis版)整合教程 3. springboot+shiro+redis(集群redis版)整合教程 参考此教程前请先阅读 2.springboot+shiro+redis(单机redis版)整合教程,此教程是在其基础上进行修改添加动态角色权限的. 本教程整合环境: java8 maven redis(单机) 开发工具: idea 版本: springboot 1.5.15.RE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kv16bM.html" rel="bookmark">项目一&colon;第十三天  1、菜单数据管理 2、权限数据管理 3、角色数据管理 4、用户数据管理 5、在realm中动态查询用户权限，角色 6、Shiro中整合ehcache缓存权限数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 课程计划 菜单数据管理 权限数据管理 角色数据管理 用户数据管理 在realm中动态查询用户权限,角色 Shiro中整合ehcache缓存权限数据         2 菜单数据添加 2.1 使用combotree父菜单项数据     1. 页面:menu_add.jsp 2. 修改组件样式:easyui-combotree,修改url  树型表格treeGrid跟下来数combotree要求数据格式基本一致. Combotree通过text属性展示文本.   3. 使用treegrid组件的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Jo9KPM.html" rel="bookmark">flask学习之配置文件的加载和动态url的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				七行代码实现一个flask app from flask import Flask app = Flask(__name__) @app.route('/') def helloworld(): return 'helloworld' if __name__ == '__main__': app.run() app.run()只适合调试,不适合生产环境使用,生产环境应该使用Gunicorn和uWSGI启动 配置管理 app.config是flask.config.Config类的实例,该类继承自			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/yMXLZXM.html" rel="bookmark">Shiro学习（6）Realm整合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.1 Realm [2.5 Realm]及[3.5 Authorizer]部分都已经详细介绍过Realm了,接下来再来看一下一般真实环境下的Realm如何实现. 1.定义实体及关系 即用户-角色之间是多对多关系,角色-权限之间是多对多关系:且用户和权限之间通过角色建立关系:在系统中验证时通过权限验证,角色只是权限集合,即所谓的显示角色:其实权限应该对应到资源(如菜单.URL.页面按钮.Java方法等)中,即应该将权限字符串存储到资源实体中,但是目前为了简单化,直接提取一个权限表,[综合示例]部			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgNylN4.html" rel="bookmark">ExtJS4&period;2学习&lpar;20&rpar;动态数据表格之前几章总结篇1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节采用技术:SpringMVC+Jetty+ExtJs4.2+Maven+MySQL5.1以上+SLF4J(前几节学习的大家不知道记住了没,现在来总结复习下,顺便加点新技术) 学习本节前的准备:Eclipse高版本,Jetty插件,Maven插件,JDK1.7 休息了好久没开动教程了,确实最近太累了,大家见谅!先来看下效果,本章节是连续篇,今天是续篇的第一讲,前面都是静态讲解,大家是不是觉得不过瘾啊?咱学Java的嘛,当然得和Java的技术结合讲解咯,前面也说到以后会用动态数据讲解的.一.准备			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZNzqD3.html" rel="bookmark">Shiro学习详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Shiro基本架构 一.什么是Shiro Apache Shiro是一个强大易用的Java安全框架,提供了认证.授权.加密和会话管理等功能: 认证 - 用户身份识别,常被称为用户“登录”: 授权 - 访问控制: 密码加密 - 保护或隐藏数据防止被偷窥: 会话管理 - 每用户相关的时间敏感的状态. 对于任何一个应用程序,Shiro都可以提供全面的安全管理服务.并且相对于其他安全框架,Shiro要简单的多. 二.Shiro的架构介绍 首先,来了解一下Shiro的三个核心组件:Subject, S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDjDxK3.html" rel="bookmark">Shiro学习（8）拦截器机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				8.1 拦截器介绍 Shiro使用了与Servlet一样的Filter接口进行扩展:所以如果对Filter不熟悉可以参考&lt;Servlet3.1规范&gt;http://www.iteye.com/blogs/subjects/Servlet-3-1了解Filter的工作原理.首先下图是Shiro拦截器的基础类图: 1.NameableFilter NameableFilter给Filter起个名字,如果没有设置默认就是FilterName:还记得之前的如authc吗?当我们组装拦截器链时会根据这个名			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3OxEg4.html" rel="bookmark" class="title">tipsWindown-iframe弹框demo-179</a>
					<div>
						&lt;link href=&quot;/themes/css/tipswindown.css&quot; rel=&quot;stylesheet&quot; type=&quot;text/css ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kmXX4.html" rel="bookmark" class="title">PHP字符串中引用变量问题</a>
					<div>
						php中字符串引用变量主要是数据库操作字符串的不同 1,普通字符串引用变量 a.外层必须引用双引号 b.字符串中的变量可写如:$s 或者{$s} 2.数据库操作字符串(数据库操作指令) a.字符串外层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JD6Vl0.html" rel="bookmark" class="title">项目梳理6&mdash;&mdash;使用WebApiTestClient为webapi添加测试</a>
					<div>
						1.使用nuget添加WebApiTestClient的引用 2.xxxxx.WebApi\Areas\HelpPage\Views\Help\Api.cshtml页面末尾添加如下代码: 3.显示结果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awKPk4.html" rel="bookmark" class="title">遮罩 HUD 指示器 蒙板 弹窗</a>
					<div>
						遮罩 HUD 指示器 蒙板 弹窗 UIAlertView的使用&lt;代理方法处理按钮点击&gt; UIAlertView *alertView = [[UIAlertView alloc] init ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRoYw0.html" rel="bookmark" class="title">Lucene&sol;Solr 搜索引擎开发 第1章</a>
					<div>
						一.本章思维导图   二.Solr的安装和部署 1.介绍Lucene和Solr分别是什么的?     Lucene是apache软件基金会4 jakarta项目组的一个子项目,是一个开放源代码的全文检 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz56BJ4.html" rel="bookmark" class="title">MFC通过对话框窗口句柄获得对话框对象指针</a>
					<div>
						C***Dialog* pWnd= (C***Dialog*)FromHandle(hWnd); //由句柄得到对话框的对象指针    pWnd-&gt;xxx( );                 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kG9DE0.html" rel="bookmark" class="title">docker学习笔记1 -- 安装和配置</a>
					<div>
						技术资料 docker中文官网:http://www.docker.org.cn/ 中文入门课程:http://www.docker.org.cn/book/docker.html docker学习笔 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGkmP0.html" rel="bookmark" class="title">Java基础知识强化之集合框架笔记37：用户登录注册案例</a>
					<div>
						1. 登录注册案例分析图解: 2. 用户登录案例 详细分析 和 分包实现: (1)用户登录案例详细分析(面向对象思想) 按照如下的操作,可以让我们更符合面向对象思想: • 有哪些类呢?         ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGPmx60.html" rel="bookmark" class="title">hdu 1565 最大点权独立集</a>
					<div>
						题意:给你一个m*n的格子的棋盘,每个格子里面有一个非负数.从中取出若干个数,使得任意的两个数所在的格子没有公共边,就是说所取数所在的2个格子不能相邻,并且取出的数的和最大. 链接:点我 分析转自:点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAGvVM.html" rel="bookmark" class="title">&lbrack;div&plus;css&rsqb;网站布局实例二</a>
					<div>
						重点: 合理应用&quot;xhtml标签&quot;建立良好的页面结构 拿到一份&quot;设计方案&quot;的效果图后不要立即开始编码,而是要 首先理清&quot;各元素之间的关系&quot;; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6bngXM.html" rel="bookmark" class="title">蜗牛&mdash;JSP学习之JavaBean初识</a>
					<div>
						初识: &lt;%@ page language=&quot;java&quot; import=&quot;java.util.*&quot; pageEncoding=&quot;utf-8&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mvrY0.html" rel="bookmark" class="title">Linux用户、组和权限</a>
					<div>
						用户.组和权限 一:概念 Linux系统是一个多用户多任务的分时操作系统,任何一个要使用系统资源的用户,都必须首先向系统管理员申请一个账号,然后以这个账号的身份进入系统.由于安全需要,「用户管理」应运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPwqOy4.html" rel="bookmark" class="title">在Windows7上搭建Cocos2d-x 3&period;2alpha0开发环境</a>
					<div>
						在windows7上搭建COCOS2D-X开发环境并不难, 但是由于框架更新过快,很多用户都有困难.我希望你们认为这个教程有用. 建议:为了避免安全相关的问题,请以管理员权限执行所有的操作,当运行命令 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bRJdm0.html" rel="bookmark" class="title">&lbrack;c&sol;c&plus;&plus;&rsqb; programming之路（13）、函数</a>
					<div>
						一.函数 1 #include&lt;stdio.h&gt; //stdio.stdlib标准库 2 #include&lt;stdlib.h&gt; 3 4 //代码重用, 函数的诞生,C语言主要是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bRwAm0.html" rel="bookmark" class="title">Eclipse运行Maven的SpringMVC项目Run on Server时出现错误：Error configuring application listener of class org&period;springframework&period;web&period;context&period;ContextLoaderListener的问题解决</a>
					<div>
						错误: 严重: Error configuring application listener of class org.springframework.web.context.ContextLoade ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dzA1z4.html" rel="bookmark" class="title">&lbrack;福利&rsqb;小木学堂前端直播分享课</a>
					<div>
						福利描述: 目前小木学堂计划每周三.周五.周日晚上8点做直播分享课,目前开课有&lt;程序员轻松应对前端开发第一季&gt;和&lt;JavaScript大神之路第一季&gt;,这两个公开直播分享课,主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38oQWg0.html" rel="bookmark" class="title">Codeforces 17D Notepad 简单数论</a>
					<div>
						由题意可知,anw =  (b-1)*b^(n-1)%c,则重点为求b^(n-1). 弱渣推不出来只能上公示. phi(c)为小于c且与c互质的个数. 当x &gt;= phi(c)时:A^x = A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjwVG4.html" rel="bookmark" class="title">&lbrack;LeetCode系列&rsqb; 变序词查找问题&lpar;Anagrams&rpar;</a>
					<div>
						给定一系列词, 找出其中所有的变序词组合. Note: 变序词 - 组成字符完全相同但次序不同的单词. 如dog和god, ate和eat. 算法描述: 使用map&lt;string, vector ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47XvK9M.html" rel="bookmark" class="title">有用的导航栏下拉代码</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoRDrb4.html" rel="bookmark" class="title">【来写个2048吧】&mdash;&mdash; 手势识别框架搭建</a>
					<div>
						迭代是一开发种技术,用来把系统功能传递到一系列的增量的完整版本,每个版本一个特定固定的时间段被开发,该时间段称之为迭代. 每个迭代的经历过程: 整个迭代过程: 图中颜色代表每次开发每项活动所占的比重不 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
